import java.util.*;

public class Check
{
	public static final int MAXD = 1000;
	public static final int MAXN = 100;
	public static final int MAXCASES = 1000;

	public static void printError(int line, String msg)
	{
		System.out.println("ERROR Line " + line + ": " + msg);
		System.exit(-1);
	}

	public static void main(String [] args)
	{
		Scanner in = new Scanner(System.in);
		int n=-1, nLines = 0, maxVal = -1;
		String line;

		while (in.hasNext()) {
			nLines++;
			n = in.nextInt();
			if (n == 0)
				break;
			if (n < 2 || n > MAXN)
				printError(nLines, "illegal value for n: " + n);
			line = in.nextLine();
			StringTokenizer st = new StringTokenizer(line);
			if (st.countTokens() != n)
				printError(nLines, "number of values != number specified");
			for(int i=0; i<n; i++) {
				int val = Integer.parseInt(st.nextToken());
				if (val < 1 || val > MAXD)
					printError(nLines, "invalid value " + val);
			}
		}
		if (in.hasNext())
			printError(nLines, "extraneous input at end of file");
		if (n != 0)
			printError(nLines, "file does not end with 0");
		if (nLines > MAXCASES+1)
			printError(nLines, "file contains too many cases");
System.exit(42);
	}
}

